#include <math.h>
#include <stdio.h>
#include "my_struct.h"

#define ALPHA -1.0
#define BETA  0.5
#define GAMMA 2.0
#define NMAX 1000
#define TINY 1.0e-10
#define GET_PSUM for(j=1;j<=ndim; j++){for(i=1,sum=0.0;i<=mpts;i++) sum+=p[i][j]; psum[j]=sum;}



void amoeba_img (double  **p, double *y, int ndim, double ftol, double(*funk)(double p[], struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf), int *nfunk, struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf);

double amotry_img (double **p, double *y, double *psum, int ndim, double(*funk)(double p[], struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf),int ihi, int *nfunk, double fac, struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf);


void amoeba_img (double  **p, double *y, int ndim, double ftol, double(*funk)(double p[], struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf), int *nfunk, struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf)
{
    int i,j,ilo,ihi, inhi, mpts=ndim+1, it=1;
    double ytry,ysave,sum,rtol,*psum;

    psum = (double *)malloc(sizeof(double)*(ndim+1));
    *nfunk = 0;     /* Number of evaluations */

        GET_PSUM




	    for (;;)
	    {
//	      printf ("Iteration %d %10.10f\n", it, ytry); 
//	      printf(".");
	      fflush(stdout);
		it++;
		ilo = 1;      /* Rank points worst .. best */
		ihi = y[1]>y[2] ? (inhi=2,1) : (inhi=1,2);
		for(i=1;i<mpts; i++)
		{
		    if (y[i] < y[ilo]) ilo = i;
		    if (y[i] > y[ihi])
		    {
			inhi = ihi;
			ihi = i;
		    } else if (y[i] > y[inhi])
			if(i != ihi) inhi = i;
		}
//		printf("");
		rtol = 2*2.0*fabs(y[ihi]-y[ilo])/(fabs(y[ihi])+fabs(y[ilo]+TINY));
//		printf("%f %f\n",rtol,ftol);

		if(rtol<ftol) break;
		if(*nfunk >= NMAX)
		{
		  //printf ("Too many iterations.\n");
		    break;
		}

		ytry = amotry_img (p,y,psum,ndim,funk,ihi,nfunk,ALPHA,img,modpar,n_mod,psf);
		//printf("AMOTRY=%g\n",ytry);
		if(ytry <= y[ilo])
		    ytry = amotry_img(p,y,psum,ndim,funk,ihi,nfunk,GAMMA,img,modpar,n_mod,psf);
		else if (ytry >= y[inhi])
		{
		    ysave = y[ihi];
		    ytry = amotry_img(p,y,psum,ndim,funk,ihi,nfunk,BETA,img,modpar,n_mod,psf);
		    if(ytry >=ysave)
		    {
			for (i=1;i<=mpts; i++)
			{
			    if (i != ilo)
			    {
				for (j=1; j<=ndim; j++)
				{
				    psum[j] = 0.5*(p[i][j]+p[ilo][j]);
				    p[i][j] = psum[j];
				}
				y[i] = (*funk)(psum,img,modpar,n_mod,psf);
			    }
			}
			*nfunk += ndim;
              GET_PSUM
		  }
		} else --(*nfunk);
	    }
        free(psum);
}

double amotry_img (double **p, double *y, double *psum, int ndim, double(*funk)(double p[], struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf), int ihi, int *nfunk, double fac, struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf)
{
    int j;
    double fac1, fac2, ytry, *ptry;

    ptry = (double *)malloc (sizeof(double) * (ndim+1));
    fac1 = (1.0-fac)/ndim;
    fac2 = fac1-fac;

    for (j=1; j<=ndim; j++)
	ptry[j] = psum[j]*fac1 -p[ihi][j]*fac2;
    ytry = (*funk)(ptry,img,modpar,n_mod,psf);
    ++(*nfunk);
    if (ytry < y[ihi])
    {
	y[ihi] = ytry;
	for (j=1; j<=ndim; j++)
	{
	    psum[j] += ptry[j]-p[ihi][j];
	    p[ihi][j] = ptry[j];
	}
    }
    free(ptry);
//    printf("%g\n",ytry);
    return ytry;
}
