/*
 * Test program to fit a 2D image to a Moffat function
 *
 * This program fit to a MOFFAT function 
 * an input FITs file!
 *
 */

#include <stdio.h> //For Standard I/O
#include <stdlib.h> //For Functions like ATOI
#include <ctype.h> //For Type check
#include <string.h> //For String manipulation
#include <math.h> //For Math functions
#include <time.h>
#include "my_math.h"
#include "my_struct.h"

#define SWAP(a,b) {temp=(a);(a)=(b);(b)=temp;}



double Model_xy(double x, double y, struct MODPAR *modpar, int n_mod);
double funk(double p[], struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf);
int my_convolve(double *image_input, int nx_image_input, int ny_image_input, double *psf, int nx_psf, int ny_psf);
int read_config(char config[80], struct MODPAR *modpar, int *n_modpar, int *add_psf_out, double *ssq_out, double *min_delta_chisq);
//int search_min(struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf, int add_psf, double ssq, double *chisq);
int search_min(struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf, int add_psf, double ssq, double *chisq,  double min_delta_chisq);

int read_n_gauss(char config[80], struct MODPAR *modpar, int *n_modpar, int *add_psf_out, double *ssq_out, double *min_delta_chisq);
int write_n_gauss(char config[80], char kind[1], struct MODPAR *modpar, int n_mod);


void n_gauss(double x, double a[], double *y, double dyda[], int na);

int search_min_n_gauss(struct IMG img, struct MODPAR *modpar, int n_mod, double *chisq);

void n_gauss(double x, double a[], double *y, double dyda[], int na) {
    int i;
    double fac,ex,arg;
    *y=0.0;
    for (i=1;i<na-1;i+=3){
	arg=(x-a[i+1])/a[i+2];
	ex=exp(-arg*arg);
	fac=a[i]*ex*2.0*arg;
	*y += a[i]*ex;
	dyda[i]=ex;
	dyda[i+1]=fac/a[i+2];
	dyda[i+2]=fac*arg/a[i+2];
    }    
}

#define MAX_MODELS 2000
int search_min_n_gauss(struct IMG img, struct MODPAR *modpar, int n_mod, double *chisq) {

  float *data,*model_data,*p_data;
  double data_temp,*dmodel;
  int naxes[2],psf_naxes[2];
  int i,k,l;
  double *a,*da;
  //int *ia;
  double *x,*y;
  int nx,ny,nx_psf,ny_psf;
  double norm_psf;
  double *index,*flux,de,z,dz,p,*sigma;;
  double ssq,d_ssq;
  int j;
  int np=9;
  double alamda;
  double **p_in,*y_in,*y_out;
  double *p_test,*p_p_test;
  double old_chisq;

  int ndim;
  double ftol;
  int nfunk;
  int niter;
  double tmp_d;
  float tmp_f;
  int tmp_i;
  int aceptable;
  int max_iter=500;
  
  int sign=1;
  double suma;

//  double **covar, **alpha, alambda;

  int *ia;
  double **covar;
  double **alpha;

  double alambda;
  struct MODPAR old_modpar[MAX_MODELS];

  ndim=n_mod*3;  

  p_test=dvector(1,ndim);
  p_p_test=dvector(1,ndim);
  ia=ivector(1,n_mod*3+1);
  covar==dmatrix(1,n_mod*3,1,n_mod*3);
  alpha==dmatrix(1,n_mod*3,1,n_mod*3);

  j=0;
  for(k=0;k<n_mod;k++) {
    for (i=0;i<3;i++) {
	  j++;
	  p_test[j]=modpar[k].a[i+1];
	  ia[j]=modpar[k].ia[i+1];
	  p_p_test[j]=modpar[k].p_a[i+1];
	  printf("%d,%d %g,%d\n",k,j,p_test[j],ia[j]);
    }
  }



  alambda=-1;
  mrqmin(img.x,img.flux,img.sigma,img.nx*img.ny,p_test,ia,ndim,covar,alpha,&ssq,n_gauss,&alambda);

  printf("mrqmin ended\n");
  fflush(stdout);
  i=1;
  for (k=0;k<n_mod;k++) {
      for(j=1;j<=modpar[k].na;j++) {
	  if (modpar[k].ia[j]==1) {
	      if (modpar[k].fixa[j]==-1) {
		  modpar[k].a[j]=p_test[i];
		  i++;
	      } else {			    
		  modpar[k].a[j]=modpar[modpar[k].fixa[j]-1].a[j]+modpar[k].p_a[j]; 
		  
	      }
	  }
	  
	  printf(" %f ",modpar[k].a[j]);  
      }
  }
  printf("\n");
  


  
    return(0);
}


int write_output(char config[80], char kind[1], struct MODPAR *modpar, int n_mod, int add_psf, double ssq, double min_delta_chisq) {
  
  FILE *fichero;
  int i,k;
  int j;
  int np;
  double alamda;
  double **p_in,*y_in;
  double *p_test,*p_p_test;
  int ndim;
  double ftol;
  int nfunk;
  int niter;
  int add_psf;
  
  double tmp_d;
  float tmp_f;
  int tmp_i;
  int aceptable;
  int n_mod;

  printf("Output File : %s\n",config);
  if ((fichero=fopen(config,kind))==NULL) {
    printf("Error opening file: %s\n",config);
    return(-1);
  } else {    
    printf("File Opened...\n");
    fprintf(fichero, "%d\n", add_psf);
    fprintf(fichero, "%d\n", n_mod);
    fprintf(fichero, "%f\n", ssq);
    fprintf(fichero, "%f\n", min_delta_chisq);
    np=9;
    ndim=0;  
    for(i=0;i<n_mod;i++) {
      fprintf(fichero,"%s\n",modpar[i].model); 
      for (j=0;j<np;) {
	j++;
	fprintf(fichero,"%g ",modpar[i].a[j]);
	fprintf(fichero,"%d ",modpar[i].ia[j]);
	fprintf(fichero,"%g ",modpar[i].p_a[j]);
	fprintf(fichero,"%d ",modpar[i].fixa[j]);
      }
    }
  }
  fclose(fichero);
  printf("File Closed\n");
  fflush(stdout);    
  return(0);
}


int write_n_gauss(char config[80], char kind[1], struct MODPAR *modpar, int n_mod) {
  
  FILE *fichero;
  int i,k;
  int j;
  int np;
  double alamda;
  double **p_in,*y_in;
  double *p_test,*p_p_test;
  int ndim;
  double ftol;
  int nfunk;
  int niter;
  int add_psf;
  
  double tmp_d;
  float tmp_f;
  int tmp_i;
  int aceptable;
  int n_mod;

  printf("Output File : %s\n",config);
  if ((fichero=fopen(config,kind))==NULL) {
    printf("Error opening file: %s\n",config);
    return(-1);
  } else {    
    printf("File Opened...\n");
    fprintf(fichero, "%d\n", n_mod);
    np=3;
    ndim=0;  
    for(i=0;i<n_mod;i++) {
      fprintf(fichero,"%s\n",modpar[i].model); 
      for (j=0;j<np;) {
	j++;
	fprintf(fichero,"%g ",modpar[i].a[j]);
	fprintf(fichero,"%d ",modpar[i].ia[j]);
	fprintf(fichero,"%g ",modpar[i].p_a[j]);
	fprintf(fichero,"%d ",modpar[i].fixa[j]);
      }
    }
  }
  fclose(fichero);
  printf("File Closed\n");
  fflush(stdout);    
  return(0);
}

int read_n_gauss(char config[80], struct MODPAR *modpar, int *n_modpar, int *add_psf_out, double *ssq_out, double *min_delta_chisq) {  
  FILE *fichero;
  int i,k;
  int j;
  int np;
  double alamda;
  double **p_in,*y_in;
  double *p_test,*p_p_test;
  int ndim;
  double ftol;
  int nfunk;
  int niter;
  int add_psf;
  
  double ssq;
  double min_delta_chisq_in;
  double tmp_d;
  float tmp_f;
  int tmp_i;
  int aceptable;
  int n_mod;

  printf("Config File : %s\n",config);
  if ((fichero=fopen(config,"r"))==NULL) {
    printf("Error opening file: %s\n",config);
    return(-1);
  } else {    
    printf("File Opened...\n");
    fscanf(fichero, "%d", &n_mod);
    printf("Num. Gauss= %d\n",n_mod);
    fflush(stdout);
    np=3;
    ndim=0;  
    for(i=0;i<n_mod;i++) {
      modpar[i].a=dvector(1,np);
      modpar[i].p_a=dvector(1,np);
      modpar[i].ia=ivector(1,np);
      modpar[i].fixa=ivector(1,np);
//      fscanf(fichero,"%s",modpar[i].model); 
      for (j=0;j<np;) {
	j++;
	fscanf(fichero,"%g",&tmp_f); 
	modpar[i].a[j]=(double)tmp_f; 
	fscanf(fichero,"%d",&tmp_i); 
	modpar[i].ia[j]=tmp_i; 
	fscanf(fichero,"%g",&tmp_f); 
	modpar[i].p_a[j]=(double)tmp_f; 
	fscanf(fichero,"%d",&tmp_i); 
	modpar[i].fixa[j]=tmp_i; 
	if (modpar[i].ia[j]==1) {
	  ndim++;
	}
      }    
      modpar[i].ia[np]=0;
      modpar[i].na=np;    
      
    }
  }
  fclose(fichero);
  printf("File Closed\n");
  fflush(stdout);    

  
  *n_modpar=n_mod;
  *add_psf_out=add_psf;
  *ssq_out=ssq;
  *min_delta_chisq=min_delta_chisq_in;

  return(0);
}



int read_config(char config[80], struct MODPAR *modpar, int *n_modpar, int *add_psf_out, double *ssq_out, double *min_delta_chisq) {

  
  FILE *fichero;
  int i,k;
  int j;
  int np;
  double alamda;
  double **p_in,*y_in;
  double *p_test,*p_p_test;
  int ndim;
  double ftol;
  int nfunk;
  int niter;
  int add_psf;
  
  double ssq;
  double min_delta_chisq_in;
  double tmp_d;
  float tmp_f;
  int tmp_i;
  int aceptable;
  int n_mod;

  printf("Config File : %s\n",config);
  if ((fichero=fopen(config,"r"))==NULL) {
    printf("Error opening file: %s\n",config);
    return(-1);
  } else {    
    printf("File Opened...\n");
    fscanf(fichero, "%d", &add_psf);
    if ((add_psf!=0)&&(add_psf!=1)) {
      add_psf=0;
    }
    printf("Add PSF=%d\n",add_psf);
    fflush(stdout);
    fscanf(fichero, "%d", &n_mod);
    printf("Num. Models= %d\n",n_mod);
    fflush(stdout);
    fscanf(fichero, "%f", &tmp_f);
    ssq=(double)tmp_f;
    printf("Chisq Lim= %f\n",ssq);
    fscanf(fichero, "%f", &tmp_f);
    min_delta_chisq_in=(double)tmp_f;
    printf("Min Delta_Chisq= %f\n",min_delta_chisq_in);
    fflush(stdout);
    np=9;
    ndim=0;  
    for(i=0;i<n_mod;i++) {
      modpar[i].a=dvector(1,np);
      modpar[i].p_a=dvector(1,np);
      modpar[i].ia=ivector(1,np);
      modpar[i].fixa=ivector(1,np);
      fscanf(fichero,"%s",modpar[i].model); 
      for (j=0;j<np;) {
	j++;
	fscanf(fichero,"%g",&tmp_f); 
	modpar[i].a[j]=(double)tmp_f; 
	fscanf(fichero,"%d",&tmp_i); 
	modpar[i].ia[j]=tmp_i; 
	fscanf(fichero,"%g",&tmp_f); 
	modpar[i].p_a[j]=(double)tmp_f; 
	fscanf(fichero,"%d",&tmp_i); 
	modpar[i].fixa[j]=tmp_i; 
	if (modpar[i].ia[j]==1) {
	  ndim++;
	}
      }
     
      modpar[i].ia[np]=0;
      modpar[i].na=np;    
      
    }
  }
  fclose(fichero);
  printf("File Closed\n");
  fflush(stdout);    

  
  *n_modpar=n_mod;
  *add_psf_out=add_psf;
  *ssq_out=ssq;
  *min_delta_chisq=min_delta_chisq_in;

  return(0);
}



#define MAX_MODELS 2000
int search_min(struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf, int add_psf, double ssq, double *chisq,  double min_delta_chisq) {

  float *data,*model_data,*p_data;
  double data_temp,*dmodel;
  int naxes[2],psf_naxes[2];
  int i,k,l;
  double *a,*da;
  int *ia;
  double *x,*y;
  int nx,ny,nx_psf,ny_psf;
  double norm_psf;
  double *index,*flux,de,z,dz,p,*sigma;;
  double ssq2,d_ssq;
  int j;
  int np=9;
  double alamda;
  double **p_in,*y_in,*y_out;
  double *p_test,*p_p_test;
  double old_chisq;

  int ndim;
  double ftol;
  int nfunk;
  int niter;
  double tmp_d;
  float tmp_f;
  int tmp_i;
  int aceptable;
  int max_iter=500;
  
  int sign=1;
  double suma;

  struct MODPAR old_modpar[MAX_MODELS];

  if ((add_psf!=0)&&(add_psf!=1)) {
    add_psf=0;
  }
  psf.npts*=add_psf;



  ndim=0;  
  for(i=0;i<n_mod;i++) {
    for (j=0;j<np;) {
      j++;	
      if (modpar[i].ia[j]==1) {
	ndim++;
      }
    }
  }

  p_in=dmatrix(1,ndim+1,1,ndim);
  p_test=dvector(1,ndim);
  p_p_test=dvector(1,ndim);
  y_in=dvector(1,ndim+1);
  y_out=dvector(1,ndim+1);
  j=0;
  for(k=0;k<n_mod;k++) {
    for (i=0;i<np;i++) {
      if (modpar[k].ia[i+1]==1) {
	if (modpar[k].fixa[i+1]==-1) {
	  j++;
	  p_test[j]=modpar[k].a[i+1];
	  p_p_test[j]=modpar[k].p_a[i+1];
	}
      }
    }
  }
  de=0.02;
  j=1;

  alamda=-1.0;  
  ssq2=funk(p_test,img,modpar,n_mod,psf);
  d_ssq=100;
  srand48( (unsigned int)time( NULL ) );
  for (j=1;j<=ndim+1;j++) {
    for (i=1;i<=ndim;i++) {
	p_in[j][i]=p_test[i]+pow(-1,floor(0.5+drand48()))*2*drand48()*p_p_test[i];
    }	
  }
  
  for (j=1;j<=ndim+1;j++) {
    for (i=1;i<=ndim;i++) {
      p_test[i]=p_in[j][i];
    }
    y_in[j]=funk(p_test,img,modpar,n_mod,psf);
  }
  
    ftol=1e-1;
    aceptable=0;

    if (ndim>0) {
	do {
	    old_chisq=y_in[1];
	    *old_modpar=*modpar;
	    amoeba_img(p_in,y_in,ndim,ftol,funk,&nfunk,img,modpar,n_mod,psf);
	    niter++;
	    if (old_chisq>y_in[1]) {		
		*modpar=*old_modpar;
	    }

	    printf("%d trys... Chisq=%f",nfunk,y_in[1]);
	    niter++;

	    /*
	     * We repeat if the CHI_SQ is not aceptable
	     */
	    i=1;
	    for (k=0;k<n_mod;k++) {
		printf("\n%s: ",modpar[k].model);
		for(j=1;j<=modpar[k].na;j++) {
		    if (modpar[k].ia[j]==1) {
			if (modpar[k].fixa[j]==-1) {
			    modpar[k].a[j]=p_in[1][i];
			    i++;
			} else {			    
// We copy from previous result
			    modpar[k].a[j]=modpar[modpar[k].fixa[j]-1].a[j]+modpar[k].p_a[j]; 

			}
		    }
		
		    printf(" %f ",modpar[k].a[j]);
		    
		
		}
	    }
	    printf("\n");
	    fflush(stdout);
	    
	    if ((niter>max_iter)||(y_in[1]<ssq)||((fabs(old_chisq-y_in[1])<min_delta_chisq))&&(y_in[1]<(10*ssq))) {
		aceptable++;
		for (i=1;i<=ndim;i++) {		    
		    p_p_test[i]=0.9*p_p_test[i];
		}		
		ssq=ssq*0.9;

		//printf("y_in=%f, ssq=%f\n",y_in[1],ssq);
	    } else {
		ftol=1e-2;
		for (j=1;j<=ndim+1;j++) {
		    for (i=1;i<=ndim;i++) {

			if (old_chisq>y_in[1]) {
			    p_p_test[i]=0.99*p_p_test[i];
			} else {
			    p_p_test[i]=1.01*p_p_test[i];
			}





			p_test[i]=p_in[j][i]+3*pow(-1,floor(0.5+drand48()))*p_p_test[i];		
/*  
			y_out[j]=funk(p_test,img,modpar,n_mod,psf);
			if (fabs(old_chisq-y_out[1])/y_out[1]<0.01) {
			    p_p_test[i]=1.01*p_p_test[i];

			} 

			if (fabs(old_chisq-y_out[1])/y_out[1]>0.01) {
			    p_p_test[i]=0.99*p_p_test[i];
			}					
*/

			    p_in[j][i]=p_in[j][i]+pow(-1,floor(0.5+drand48()))*drand48()*p_p_test[i];			    

		    }	
		}	    
		for (j=1;j<=ndim+1;j++) {
		    for (i=1;i<=ndim;i++) {
			p_test[i]=p_in[j][i];
		    }
		    y_in[j]=funk(p_test,img,modpar,n_mod,psf);
		}
	    }
	    
	} while (aceptable<6);
    }



 
// Final results!




    i=1;
    for (k=0;k<n_mod;k++) {
	printf("\n%s: ",modpar[k].model);
	for(j=1;j<=modpar[k].na;j++) {
	    if (modpar[k].ia[j]==1) {
		if (modpar[k].fixa[j]==-1) {
		    modpar[k].a[j]=0;
		    suma=0;
/*
		    for (l=1;l<=ndim+1;l++) {
			modpar[k].a[j]+=p_in[l][i];
			suma+=1/y_in[j];
		    }
		    modpar[k].a[j]/=(ndim+1);
*/
			modpar[k].a[j]+=p_in[1][i];
		    modpar[k].p_a[j]=0;
		    for (l=1;l<=ndim+1;l++) {
			modpar[k].p_a[j]+=pow(modpar[k].a[j]-p_in[l][i],2);
		    }
		    modpar[k].p_a[j]=sqrt(modpar[k].p_a[j]);

		    if (ndim>1) {
			modpar[k].p_a[j]/=ndim;
		    } 

		    i++;
		} else {			    
		    modpar[k].a[j]=modpar[modpar[k].fixa[j]-1].a[j]+modpar[k].p_a[j]; // We copy from previous result
		    modpar[k].p_a[j]=modpar[modpar[k].fixa[j]-1].p_a[j];
		}
	    }
		printf(" %5.2f+-%5.2f ",modpar[k].a[j],modpar[k].p_a[j]);
	}
    }

    

  free(p_in);
  free(p_test);
  free(p_p_test);
  free(y_in);
  free(y_out);

    return(0);
}


double funk(double p[], struct IMG img, struct MODPAR *modpar, int n_mod, struct PSF psf) {
    int i,j,k;
    double tp;
    double chisq;
    double *model;
    int ndim;
    chisq=0.0;
    /*
     * We change the model parameters if needed
     *
     * fixa will indicate
     */
    i=1;
    for (k=0;k<n_mod;k++) {
      for(j=1;j<=modpar[k].na;j++) {
	if (modpar[k].ia[j]==1) {
	  if (modpar[k].fixa[j]==-1) {
	    modpar[k].a[j]=p[i];
	    i++;
	  } else {
	    modpar[k].a[j]=modpar[modpar[k].fixa[j]-1].a[j]+modpar[k].p_a[j]; // We copy from previous result
//	    modpar[k].a[j]=modpar[modpar[k].fixa[j]].a[j]+modpar[k].p_a[j]; // We copy from previous result
	  }
	}
	/*
	    if (modpar[k].ia[j]==1) {
	    modpar[k].a[j]=p[i];
	    i++;
	    }
	  */
      }
    }
    ndim=i-1;

    /*
     * We build the images!
     */
    model = (double *)malloc(img.nx*img.ny*sizeof(double));  
    for (j=0;j<img.ny;j++) {
	for (i=0;i<img.nx;i++) {
//	    model[i+j*img.nx]=Model_xy((double)i,(double)j,modpar,n_mod);
	    model[i+j*img.nx]=Model_xy(img.x[i+j*img.nx],img.y[i+j*img.nx],modpar,n_mod);
	}
    }

    /*
     * Now we convolve by the PSF
     */ 

    if (psf.npts!=0) {
	my_convolve(model,img.nx,img.ny,psf.flux,psf.nx,psf.ny);
    }


    /* 
     * We determine the CHISQ
     */		
//    printf("NX_Y=%d,%d",img.nx,img.ny);
    chisq=0.0;
    for (j=0;j<img.ny;j++) {
	for (i=0;i<img.nx;i++) {
//	  if ((i!=0)&&(j!=0)) {
	    chisq=chisq+(pow((img.flux[i+j*img.nx]-model[i+j*img.nx]),2))/(pow(img.sigma[i+j*img.nx],2));
//	    printf("CHISQ=%g\n",chisq);
//	  }
	    if (chisq!=chisq) chisq=0.0;
	}
    }
    
    chisq/=(img.nx*img.ny-ndim-1);
    free(model);

    return chisq;
}

  
/*
 * Model XY function
 */
double Model_xy(double x, double y, struct MODPAR *modpar, int n_mod) {
  double x_c,y_c,pre_pa,pa,q;
  double Im,r_m,beta;
  double xp,yp,r;
  double flux,flux_tmp;
  double c;
  int nnx,j;
  flux=0.0;
  for (j=0;j<n_mod;j++) {
    x_c=modpar[j].a[1];
    y_c=modpar[j].a[2];
    Im=modpar[j].a[3];
    r_m=modpar[j].a[4];
    beta=modpar[j].a[5];
    pre_pa=modpar[j].a[6];
    pa=(3.14159/180.0)*modpar[j].a[6];
    while (pa>2*3.14159) {
      pa-=2*3.14159;
    }
    while (pa<0) {
      pa+=2*3.14159;
    }
    q=modpar[j].a[7];
    c=modpar[j].a[8];
    xp=(x-x_c)*cos(pa)+(y-y_c)*sin(pa);
    yp=(y-y_c)*cos(pa)-(x-x_c)*sin(pa);
    r=pow((pow(xp,(c+2))+pow(yp/q,(c+2))),1/(c+2));
    flux_tmp=0.0;
    if(strcmp(modpar[j].model, "moffat") == 0)
      flux_tmp=Im/(pow((1+pow((r/r_m),2)),beta));
    else if(strcmp(modpar[j].model, "gauss") == 0)
      flux_tmp=Im*exp(-pow((r/(2*r_m)),2));
    else if(strcmp(modpar[j].model, "disk") == 0)
      flux_tmp=Im*exp(-(r/r_m));
    else if(strcmp(modpar[j].model, "vauc") == 0)
      flux_tmp=Im*exp(-7.67*(pow(r/r_m,0.25)-1));
    else if(strcmp(modpar[j].model, "back") == 0)
      flux_tmp=Im;
    else if(strcmp(modpar[j].model, "gauss1d") == 0)
      flux_tmp=Im*exp(-pow(((x-fabs(x_c)+fabs(y_c))/(2*fabs(r_m))),2));
    else if(strcmp(modpar[j].model, "poly1d") == 0) 
	flux_tmp=x_c+y_c*x+Im*pow(x,2)+r_m*pow(x,3)+beta*pow(x,4)+pre_pa*pow(x,5)+q*pow(x,6)+c*pow(x,7);
    flux+=flux_tmp;
  }
//  printf("(%g,%g),Im=%f,flux=%g,n_mod=%d\n",x,y,Im,flux,n_mod);
  return flux;
}




